import request from '@/utils/request'

interface Template {
  id: string;
  name: string;
  [key: string]: any;
  // Add other relevant fields
}

interface UpdateTemplatePayload {
  id: string;
  // Add fields to update
}

interface CreateTemplatePayload {
  name: string;
  // Add other fields for creation
}

export function fetchTemplateById(id: string) {
  return request<Template>({
    method: 'GET',
    url: `/gen/template/get`, // Adjust URL if needed
    params: { id },
  });
}

export function updateTemplate(payload: UpdateTemplatePayload) {
  return request<void>({
    method: 'POST', // Adjust method if needed
    url: `/gen/template/update`, // Adjust URL if needed
    data: payload, // Adjust payload structure if needed
  });
}

export function fetchTemplatePage() {
  return request<Template[]>({
    method: 'POST', // Adjust method if needed
    url: `/gen/template/page`, // Adjust URL if needed
    // Add pagination parameters if needed
  });
}

export function fetchAllTemplates() {
  return request<Template[]>({
    method: 'POST', // Adjust method if needed
    url: `/gen/template/list-all`, // Adjust URL if needed
  });
}

export function deleteTemplates(ids: string[]) {
  return request<void>({
    method: 'POST', // Adjust method if needed
    url: `/gen/template/delete`, // Adjust URL if needed
    data: { ids }, // Adjust payload structure if needed
  });
}

export function createTemplate(payload: CreateTemplatePayload) {
  return request<void>({
    method: 'POST', // Adjust method if needed
    url: `/gen/template/create`, // Adjust URL if needed
    data: payload, // Adjust payload structure if needed
  });
}